/*
 * Display client to access display servers.
 *
 * Copyright (C) 2018 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#include <l4/cxx/ipc_stream>
#include <l4/re/env>
#include <l4/sys/err.h>

#include "display-client.h"

#include <stdint.h>

int
Display_device_interface::disable() throw()
{
  L4::Ipc::Iostream s(l4_utcb());

  return l4_error(s.call(cap(), Display_op_disable));
}

int
Display_device_interface::enable() throw()
{
  L4::Ipc::Iostream s(l4_utcb());

  return l4_error(s.call(cap(), Display_op_enable));
}
