/*
 * Framebuffer client to access framebuffer servers.
 *
 * Copyright (C) 2018 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

#ifdef __cplusplus

#include <l4/re/dataspace>
#include <l4/re/env>
#include <l4/re/c/video/view.h>
#include <l4/sys/types.h>

class Framebuffer_device_interface : public L4::Kobject_t<Framebuffer_device_interface, L4::Kobject>
{
  L4_KOBJECT(Framebuffer_device_interface)

public:
  int get_framebuffer(L4::Cap<L4Re::Dataspace> mem) throw();
  l4_size_t get_framebuffer_size() throw();
  int get_view_info(l4re_video_view_info_t *view_info) throw();
};

#endif
