/*
 * Input event client to access input event servers.
 *
 * Copyright (C) 2018 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

#ifdef __cplusplus

#include <l4/re/dataspace>
#include <l4/re/env>
#include <l4/re/event>
#include <l4/sys/capability>
#include <l4/sys/icu>
#include <l4/sys/types.h>

class Input_event_interface : public L4::Kobject_t<Input_event_interface,
                                                   L4::Kobject,
                            /* PROTO_ANY */        0,
                            /* accepts one cap */  L4::Type_info::Demand_t<1> >
{
public:
  int bind(unsigned irqnum, L4::Cap<L4::Irq> irq) throw();
  int get_buffer(L4::Cap<L4Re::Dataspace> mem) throw();
};

#endif
