/*
 * Input event server operations.
 *
 * Copyright (C) 2018 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

#include <l4/re/protocols.h>
#include <l4/sys/types.h>

enum Input_event_protocols
{
  Input_event_proto_event = L4RE_PROTO_EVENT,
  Input_event_proto_icu   = L4_PROTO_IRQ,
};

enum Input_event_operations
{
  /* Event protocol operations.
     NOTE: These definitions should employ the values defined elsewhere. */

  Input_event_op_get_buffer               = 0,
  Input_event_op_get_num_streams          = 1,
  Input_event_op_get_stream_info          = 2,
  Input_event_op_get_stream_info_for_id   = 3,
  Input_event_op_get_axis_info            = 4,
  Input_event_op_get_stream_state_for_id  = 5,

  /* IRQ protocol operations.
     See: pkg/l4re-core/l4sys/include/icu.h */

  Input_event_op_bind                     = L4_ICU_OP_BIND,
};
