/*
 * LCD device support for the Letux 400 notebook computer.
 *
 * Copyright (C) 2018 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

#include "lcd-jz4740-device.h"

#ifdef __cplusplus

class Lcd_letux400 : public Lcd_jz4740_device
{
public:
  /* Inherit constructor. */

  Lcd_letux400(Lcd_chip *chip, L4::Cap<Display_device_interface> display)
  : Lcd_jz4740_device(chip, display)
  {
  }

  /* Common device instance. */

  static Lcd_letux400 *device;
};

#endif
