/*
 * Common LCD device functionality.
 *
 * Copyright (C) 2018 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#include "lcd-device.h"

void Lcd_device::disable_display()
{
  _display->disable();
}

void Lcd_device::enable_display()
{
  _display->enable();
}

// C language interface.

void *lcd_get_device()
{
  return (void *) Lcd_device::get_device();
}

l4_addr_t lcd_get_framebuffer(void *lcd)
{
  return static_cast<Lcd_device *>(lcd)->get_framebuffer();
}

l4_size_t lcd_get_framebuffer_size(void *lcd)
{
  return static_cast<Lcd_device *>(lcd)->get_framebuffer_size();
}

void lcd_get_view_info(void *lcd, l4re_video_view_info_t *view_info)
{
  return static_cast<Lcd_device *>(lcd)->get_view_info(view_info);
}

void lcd_disable(void *lcd)
{
  static_cast<Lcd_device *>(lcd)->disable();
}

void lcd_enable(void *lcd)
{
  static_cast<Lcd_device *>(lcd)->enable();
}
