/*
 * Keypad description access.
 *
 * Copyright (C) 2018 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

#include <l4/sys/types.h>

#ifdef __cplusplus

class Keypad
{
public:
  virtual int columns(void) = 0;
  virtual int rows(void) = 0;
  virtual int code(int column, int row) = 0;
  static Keypad *get_keypad();
};

#endif

/* C language interface. */

EXTERN_C_BEGIN

void *keypad_get(void);
int keypad_columns(void *keypad);
int keypad_rows(void *keypad);
int keypad_code(void *keypad, int column, int row);

EXTERN_C_END
