/*
 * General keypad mapping support.
 *
 * Copyright (C) 2018 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#include "keypad.h"

/* Obtain the common instance. */
     
void *keypad_get(void)
{
  return reinterpret_cast<void *>(Keypad::get_keypad());
}    

/* Number of keypad columns. */

int keypad_columns(void *keypad)
{
  return static_cast<Keypad *>(keypad)->columns();
}

/* Number of keypad rows, used by each value in the column array. */

int keypad_rows(void *keypad)
{
  return static_cast<Keypad *>(keypad)->rows();
}

/* Keycode accessors. */

int keypad_code(void *keypad, int column, int row)
{
  return static_cast<Keypad *>(keypad)->code(column, row);
}
