/*
 * Test dynamic loading.
 *
 * Copyright (C) 2018 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#include <l4/util/util.h>
#include <dlfcn.h>
#include <stdio.h>

static const char *libname = "rom/libdl_test_data.so";

int main(void)
{
  const char *buffer;

  /* Obtain the linked data. */

  void *handle = dlopen(libname, RTLD_NOW);
  const char *(*get_data)(void);

  if (handle == NULL)
  {
    printf("Could not open %s\n", libname);
    return 1;
  }

  get_data = dlsym(handle, "get_data");

  /* Load and show the data. */

  buffer = get_data();
  puts(buffer);

  l4_sleep_forever();
  return 0;
}
