/*
 * Memory allocation utility functions.
 *
 * Copyright (C) 2018 Paul Boddie <paul@boddie.org.uk>
 * Subject to other copyrights, being derived from the existing L4Re
 * LCD driver implementations.
 *
 * This file is part of TUD:OS and distributed under the terms of the
 * GNU General Public License 2.
 * Please see the COPYING-GPL-2 file for details.
 */

#ifndef __DRIVERS_LCD_ARCH_JZ4740_MEMORY_H__
#define __DRIVERS_LCD_ARCH_JZ4740_MEMORY_H__

#include <l4/io/io.h>
#include <l4/re/env.h>
#include <l4/util/util.h>

int get_device(char const *hid, l4io_device_handle_t *dh,
               l4io_resource_handle_t *rh);

int get_resource(l4io_device_handle_t dh, l4io_resource_t *res,
                 enum l4io_resource_types_t type);

int get_memory(char const *hid, l4_addr_t *start, l4_addr_t *end);

#endif /* __DRIVERS_LCD_ARCH_JZ4740_MEMORY_H__ */
