/*
 * Test a Vcon interface.
 *
 * Copyright (C) 2018 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#include <l4/re/env>
#include <l4/sys/vcon>
#include <l4/util/util.h>

#include <string.h>

static const char *buffer = "Hello world!";

int main(int argc, char *argv[])
{
  const char *cap = argc < 2 ? "term" : argv[1];

  /* Obtain a reference to the virtual console. */

  L4::Cap<L4::Vcon> vcon = L4Re::Env::env()->get_cap<L4::Vcon>(cap);
  if (!vcon.is_valid()) return 1;

  while (1)
  {
    vcon->write(buffer, strlen(buffer));
    l4_sleep(1000);
  }

  return 0;
}
